<template>
  <div>
    <card-container>
      <vxe-toolbar>
        <template #buttons>
          <el-button icon="el-icon-plus" type="primary" size="small" @click="isShowAdd = true">新增</el-button>
          <el-button icon="el-icon-search" type="primary" plain size="small" @click="getList">搜索</el-button>
        </template>
      </vxe-toolbar>
      <vxe-table
        ref="table"
        stripe
        style="margin-top: 10px;"
        :loading="loading"
        keep-source
        show-overflow
        :column-config="{ resizable: true }"
        :edit-rules="validRules"
        :edit-config="{ trigger: 'manual', mode: 'row', showStatus: true, isHover: true, autoClear: false }"
        :align="allAlign"
        :data="tableData"
      >
        <vxe-column field="users" title="通知人员" type="expand" width="60" align="center">
          <template #content="{ row }">
            <div style="padding: 10px;white-space: pre-wrap;">
              <el-tag v-for="item in row.users" type="success" style="margin: 4px;">{{ item.name }}（读 回）</el-tag>
            </div>
          </template>
        </vxe-column>
        <vxe-column type="seq" width="58" align="center" />
        <vxe-column field="title" width="170" title="通知提醒" />
        <vxe-column field="admin.name" width="140" title="发布人" align="center" />
        <vxe-column field="created_at" width="180" title="发出时间" align="center" />
        <vxe-column field="deadline" width="180" title="截止时间" align="center" />
        <vxe-column field="operate" title="操作" min-width="220">
          <template #default="{ row }">
            <template v-if="isActiveStatus(row)">
              <el-button size="small" type="primary" @click="saveRowEvent(row)">保存</el-button>
              <el-button size="small" type="primary" plain @click="cancelRowEvent(row)">取消</el-button>
            </template>
            <template v-else>
              <el-button size="small" type="warning" @click="editRowEvent(row)">编辑</el-button>
              <el-button size="small" type="danger" @click="destroyRowEvent(row)">删除</el-button>
            </template>
          </template>
        </vxe-column>
      </vxe-table>

      <el-pagination
        style="margin-top: 10px;"
        :current-page.sync="select.page"
        :page-sizes="[20, 30, 40, 50]"
        :page-size.sync="select.page_size"
        layout="total, sizes, prev, pager, next, jumper"
        :total="total"
        @size-change="e => {
          select.page_size = e;
          select.page = 1;
          getList();
        }"
        @current-change="e => {
          select.page = e;
          getList();
        }"
      />
    </card-container>
    <add-notice ref="AddNotice" :is-show.sync="isShowAdd" @refresh="getList" />
  </div>
</template>

<script>
import { deepCopy } from '@/utils'
import { index, save, destroy } from '@/api/notice'
import AddNotice from './components/AddNotice.vue'
export default {
  components: {
    AddNotice
  },
  data() {
    return {
      isShowAdd: false,

      loading: false,
      select: {
        page: 1,
        page_size: 20,
        'show_relation[0]': 'admin',
        'show_relation[1]': 'users',
      },
      total: 0,
      allAlign: null,
      tableData: [],
      validRules: {},
      form: {
        id: '',
        title: '',
        content: '',
        files: '',
        deal_type: '',
        reply_fields: '',
        reply_need_files: '',
        deadline: '',
        user_ids: []
      }
    }
  },
  computed: {
    isActiveStatus() {
      return function(row) {
        if (this.$refs['table']) {
          return this.$refs['table'].isEditByRow(row)
        }
      }
    }
  },
  created() {
    this.getList()
  },
  methods: {
    editRowEvent(row) {
      this.$refs['AddNotice'].id = row.id
      this.$refs['AddNotice'].type = 'edit'
      this.isShowAdd = true
      // if (this.$refs['table']) {
      //   this.$refs['table'].setEditRow(row)
      // }
    },
    cancelRowEvent(row) {
      if (this.$refs['table']) {
        this.$refs['table'].clearEdit().then(() => {
          // 还原行数据
          this.$refs['table'].revertData(row)
        })
      }
    },

    async getList() {
      this.loading = true
      try {
        const res = await index(this.select)
        this.tableData = res.data
        this.total = res.total
        this.loading = false
      } catch (err) {
        console.error(err)
        this.loading = false
      }
    },

    async saveRowEvent(row) {
      try {
        const errMap = await this.$refs['table'].validate()
        if (errMap) {
          throw new Error(errMap)
        }
        await this.$confirm('确认保存？', '提示', {
          confirmButtonText: '确认',
          cancelButtonText: '取消'
        })
        await this.$refs['table'].clearEdit()
        const form = deepCopy(this.form)
        for (const key in form) {
          form[key] = row[key]
        }
        if (!form.password) {
          delete form.password
        }
        this.loading = true
        await save(form)
        await this.getList()
        this.loading = false
      } catch (err) {
        this.loading = false
      }
    },
    async destroyRowEvent(row) {
      try {
        await this.$confirm('确认删除？', '提示', {
          confirmButtonText: '确认',
          cancelButtonText: '取消'
        })
        this.loading = true
        if (row.id) {
          await destroy({
            id: row.id
          })
          await this.getList()
        } else {
          console.log(row)
          this.tableData.splice(this.tableData.findIndex(i => i._X_ROW_KEY === row._X_ROW_KEY), 1)
        }
        this.loading = false
      } catch (err) {
        this.loading = false
      }
    }
  }
}
</script>

<style scoped lang="scss">
.total {
  color: #666;
  text-align: right;
  line-height: 3;
}
::v-deep .el-tag + .el-tag {
  margin-left: 4px;
}
</style>
